package com.unitesk.requality.core.domproxy;


import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.dom4j.Document;
import org.dom4j.DocumentFactory;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;

import com.unitesk.requality.core.TreeNode;

public class LinkResolver {
	public LinkResolver(){
	}
	Document proxy = null;
	public TreeNode resolveSingle(TreeNode targ, String path){
		if(proxy == null)
			proxy = DocumentHelper.createDocument(RequalityElement.toElement(targ.getTreeDB().getRootNode()));
		RequalityElement.toElement(targ.getTreeDB().getRootNode()).setDocument(proxy);
		RequalityElement rer = RequalityElement.toElement(targ);
		org.dom4j.XPath xpath=proxy.createXPath(path);
		Object result=xpath.evaluate(rer);
 		if(result instanceof Collection<?>){
			List<TreeNode> res= new ArrayList<TreeNode>();
			for(Element re:(Collection<Element>)result)
				res.add(((RequalityElement) re).getWrappedTreeNode());
			if(res.size()==0)
				return null;
			return res.get(0);
		}
		if(result instanceof RequalityElement){
			return ((RequalityElement)result).getWrappedTreeNode();
		}
		return null;
	}
	public TreeNode[] resolve(TreeNode targ, String path){
		if(proxy == null)
			proxy = DocumentHelper.createDocument(RequalityElement.toElement(targ.getTreeDB().getRootNode()));
		RequalityElement.toElement(targ.getTreeDB().getRootNode()).setDocument(proxy);
		RequalityElement rer = RequalityElement.toElement(targ);
		org.dom4j.XPath xpath=proxy.createXPath(path);
		Object result=xpath.evaluate(rer);
 		if(result instanceof Collection<?>){
			List<TreeNode> res= new ArrayList<TreeNode>();
			for(Element re:(Collection<Element>)result)
				res.add(((RequalityElement) re).getWrappedTreeNode());
			if(res.size()==0)
				return null;
			return res.toArray(new TreeNode[0]);
		}
		if(result instanceof RequalityElement){
			return new TreeNode[]{((RequalityElement)result).getWrappedTreeNode()};
		}
		return null;
	}
}
