package com.unitesk.requality.eclipse.views.documents;

/**
 * That class keeps location (start, end) of the span in the string
 * representation of the document.
 */
public class SpanLocation {
    
    protected LocationPosition location;
    protected String spanId;
	protected String spanText;
    
    public SpanLocation(final LocationPosition location, final String spanId, final String spanText) {
        this.location = location;
        this.spanId = spanId;
        this.spanText = spanText;
    }
    
    public String toString() {
        return location.toString() + " spanId:<" + spanId + "> spanText:<" + spanText + ">";
    }
    
    public String getSpanId() {
        return spanId;
    }
    
    public LocationPosition getLocation() {
        return location;
    }
    
    public String getText() {
    	return spanText;
    }
}
