package com.unitesk.requality.tests;

import org.eclipse.jface.wizard.IWizard;
/**
 * Wizard used to alter settings of coverage source.
 * It tends to load settings on setCoverageStorageSettings call
 * and save changed settings on performFinish().
 * @author kildishev
 *
 */
public interface ICoverageSourceWizard extends IWizard {
	/**
	 * Define current settings that were stored in past.s
	 * @param split settings over coverage source
	 */
	void setCoverageStorageSettings(String[] split);

}
