package com.unitesk.requality.core.checkers;

import com.unitesk.requality.core.TreeNode;

/**
 * 
 * Class used to detect problems over Tree Nodes
 *
 */
public interface IChecker {
	/**
	 * Method used to check single node for problems
	 * @param node node to check
	 * @return array of problems, empty if there is no problems
	 */
    public abstract CheckerProblem[] check(TreeNode node);
}
