package com.unitesk.requality.core.domproxy;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.w3c.dom.Attr;
import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.TypeInfo;
import org.w3c.dom.UserDataHandler;
import org.xml.sax.InputSource;

import com.unitesk.requality.core.Attribute;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.TreeNodeComparator;
import com.unitesk.requality.eclipse.ui.cnf.RequalitySorter;

public class RequalityW3CElement extends org.apache.xerces.dom.ElementImpl {
	private int index;
	public RequalityW3CElement( int index, TreeNode targ2) {
		targ = targ2;
		this.index = index;
	}

	@Override
	public Node appendChild(Node arg0) throws DOMException {
		return null;
	}

	@Override
	public Node cloneNode(boolean arg0) {
		return null;
	}
	private TreeNode targ;
	@Override
	public NamedNodeMap getAttributes() {
		final Map<String,Attribute> map = targ.getAttributes();
		final ArrayList<String>keys = new ArrayList<String>(map.keySet());
		return new NamedNodeMap() {
			@Override
			public Node setNamedItemNS(Node arg0) throws DOMException {
				return null;
			}
			
			@Override
			public Node setNamedItem(Node arg0) throws DOMException {
				return null;
			}
			
			@Override
			public Node removeNamedItemNS(String arg0, String arg1) throws DOMException {
				return null;
			}
			
			@Override
			public Node removeNamedItem(String arg0) throws DOMException {
				return null;
			}
			
			@Override
			public Node item(int arg0) {
				if(arg0<0||arg0>=getLength())
					return null;
				return RequalityW3CAttribute.toAttr(arg0, RequalityW3CElement.this,(Attribute)(map.values().toArray()[arg0]));
			}
			
			@Override
			public Node getNamedItemNS(String arg0, String arg1) throws DOMException {
				return getNamedItem(arg1);
			}
			
			@Override
			public Node getNamedItem(String arg0) {
				if(keys.indexOf(arg0)<0)
					return null;
				return RequalityW3CAttribute.toAttr(keys.indexOf(arg0), RequalityW3CElement.this, map.get(arg0));
			}
			
			@Override
			public int getLength() {
				return map.values().size();
			}
		};
	}
	@Override
	public NodeList getChildNodes() {
		return new NodeList() {
			
			@Override
			public Node item(int arg0) {
				if(arg0<0||arg0>=getLength())
					return null;
				return RequalityW3CElement.toElement(arg0, targ.getChild(arg0));
			}
			
			@Override
			public int getLength() {
				return targ.sizeChildren();
			}
		};
	}

	@Override
	public Node getFirstChild() {
		TreeNode[]nodes = targ.getSortedChildren();
		if(nodes.length==0)
			return null;
		return toElement(0, targ.getSortedChildren()[0]);
	}

	@Override
	public Node getLastChild() {
		TreeNode[]nodes = targ.getSortedChildren();
		if(nodes.length==0)
			return null;
		return toElement(nodes.length-1,nodes[nodes.length-1]);
	}

	@Override
	public String getLocalName() {
		return targ.getType();
	}

	@Override
	public Node getNextSibling() {
		Node parent = getParentNode();
		if(parent == null)
			return null;
		NodeList nl = parent.getChildNodes();
		if(index>=nl.getLength())
			return null;
		return nl.item(index+1);
	}

	@Override
	public String getNodeName() {
		return targ.getType();
	}

	@Override
	public short getNodeType() {
		return ELEMENT_NODE;
	}

	@Override
	public String getNodeValue() throws DOMException {
		return "";
	}

	@Override
	public Document getOwnerDocument() {
		return null;
	}

	@Override
	public Node getParentNode() {
		return RequalityW3CElement.toElement(targ.getParent());
	}

	@Override
	public String getPrefix() {
		return "";
	}

	@Override
	public Node getPreviousSibling() {
		Node parent = getParentNode();
		if(parent == null)
			return null;
		NodeList nl = parent.getChildNodes();
		if(index<=0)
			return null;
		return nl.item(index-1);
	}

	@Override
	public String getTextContent() throws DOMException {
		return "";
	}

	@Override
	public boolean hasAttributes() {
		return targ.getAttributeKeys().size()>0;
	}

	@Override
	public boolean hasChildNodes() {
		return targ.sizeChildren()>0;
	}
	@Override
	public boolean isEqualNode(Node arg0) {
		return ((RequalityW3CElement)arg0).getWrappedTreeNode().equals(getWrappedTreeNode());
	}

	public TreeNode getWrappedTreeNode() {
		return targ;
	}

	@Override
	public boolean isSameNode(Node arg0) {
		return isEqualNode(arg0);
	}

	@Override
	public boolean isSupported(String arg0, String arg1) {
		return true;
	}


	@Override
	public Node removeChild(Node arg0) throws DOMException {
		return null;
	}

	@Override
	public Node replaceChild(Node arg0, Node arg1) throws DOMException {
		return null;
	}

	@Override
	public void setNodeValue(String arg0) throws DOMException {
	}

	@Override
	public void setPrefix(String arg0) throws DOMException {
	}

	@Override
	public void setTextContent(String arg0) throws DOMException {
	}

	@Override
	public Object setUserData(String arg0, Object arg1, UserDataHandler arg2) {
		return null;
	}

	private static Map<TreeNode,RequalityW3CElement> map = new HashMap<TreeNode,RequalityW3CElement>();
	public static RequalityW3CElement toElement(int index, TreeNode targ) {
		if(!map.containsKey(targ))
			 map.put(targ, new RequalityW3CElement(index, targ));
		return map.get(targ);
	}
	public static RequalityW3CElement toElement(TreeNode targ) {
		if(!map.containsKey(targ))
			return null;
		return map.get(targ);
	}

	@Override
	public String getAttribute(String arg0) {
		return ((RequalityW3CAttribute)getAttributes().getNamedItem(arg0)).getValue();
	}

	@Override
	public String getAttributeNS(String arg0, String arg1) throws DOMException {
		return ((RequalityW3CAttribute)getAttributes().getNamedItemNS(arg0,arg1)).getValue();
	}

	@Override
	public Attr getAttributeNode(String arg0) {
		return ((RequalityW3CAttribute)getAttributes().getNamedItem(arg0));
	}

	@Override
	public Attr getAttributeNodeNS(String arg0, String arg1)
			throws DOMException {
		return ((RequalityW3CAttribute)getAttributes().getNamedItemNS(arg0,arg1));
	}

	@Override
	public NodeList getElementsByTagName(String arg0) {
		final TreeNode[]chi = targ.getSortedChildren(arg0);
		return new NodeList() {
			
			@Override
			public Node item(int arg0) {
				if(arg0<0||arg0>=getLength())
					return null;
				return RequalityW3CElement.toElement(arg0,chi[arg0]);
			}
			
			@Override
			public int getLength() {
				return chi.length;
			}
		};
	}

	@Override
	public NodeList getElementsByTagNameNS(String arg0, String arg1)
		throws DOMException {
		return getElementsByTagName(arg1);
	}

	@Override
	public String getTagName() {
		return targ.getType();
	}

	@Override
	public boolean hasAttribute(String arg0) {
		return targ.getAttribute(arg0)!=null;
	}

	@Override
	public boolean hasAttributeNS(String arg0, String arg1) throws DOMException {
		return hasAttribute(arg1);
	}

	@Override
	public void removeAttribute(String arg0) throws DOMException {
		
	}

	@Override
	public void removeAttributeNS(String arg0, String arg1) throws DOMException {
		
	}

	@Override
	public Attr removeAttributeNode(Attr arg0) throws DOMException {
		return null;
	}

	@Override
	public void setAttribute(String arg0, String arg1) throws DOMException {
		
	}

	@Override
	public void setAttributeNS(String arg0, String arg1, String arg2)
			throws DOMException {
		
	}

	@Override
	public Attr setAttributeNode(Attr arg0) throws DOMException {
		return null;
	}

	@Override
	public Attr setAttributeNodeNS(Attr arg0) throws DOMException {
		return null;
	}

	@Override
	public void setIdAttribute(String arg0, boolean arg1) throws DOMException {
		
	}

	@Override
	public void setIdAttributeNS(String arg0, String arg1, boolean arg2)
			throws DOMException {
		
	}

	@Override
	public void setIdAttributeNode(Attr arg0, boolean arg1) throws DOMException {
		
	}

}
